﻿package {

    import flash.display.*;
    import flash.text.*;
    import flash.net.*;
    import flash.events.*;
    import flash.utils.*;
    import flash.ui.Keyboard;
    import flash.utils.setTimeout;
    import flash.geom.*;
    import com.nitoyon.potras.*;
    import com.bigchu.display.MotionPoint;
    import com.bigchu.display.StopPoint3D;


    public class WcanAsMiniVol4 extends MovieClip {
        
        public var bg: MovieClip;
        public var frame: MovieClip;
        public var canvas: MovieClip;
        public var demo: MovieClip;

        public var arm: MovieClip;
        public var mouth: MovieClip;

        private var index: int = 0;
        private var indexBuff: int = 0;
		private var so: SharedObject;
		private var typingNumber: int;

        // BezierCurve
        private var maxPointNumber: uint;
        private var maxCtrlPointNumber: uint;
        private var maxTPointNumber: uint;
        private var lineWeight: Number;
        private var bezierPoints: Array;
        private var ctrlPoints: Array;

        private var lineOnryFlg: Boolean = true; // 補助線等

        public static const COLOR_BG: uint = 0x070400;
        public static const COLOR_NORMAL: uint = 0xeee6d1;
        public static const COLOR_CATCH: uint = 0xab4109;
        public static const COLOR_CHAPTER: uint = 0Xc09f44;
        public static const COLOR_HIDE: uint = 0x333333;

        public static const BEZIER_POINT_RADIUS: uint = 6;
        public static const CTRL_POINT_RADIUS: uint = 6;

        // slide
        private var page: Array = [
            {size : 30, scale : 1.4, color : COLOR_NORMAL, text : "「ＡＳ３でベジェ曲線」"},
            {size : 30, scale : 3, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "はじめに"},
            {size : 24, scale : 1, color : COLOR_NORMAL, text : "今回のスライドでは\nnitoyonさんの作ったライブラリ\n｢potrAs｣を活用させていただきました"},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "ありがとうございます"},
            {size : 30, scale : 3, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "自己紹介"},
            {size : 30, scale : 3, color : COLOR_NORMAL, text : "id:bigchu"},
            {size : 24, scale : 1.6, color : COLOR_NORMAL, text : "金井正裕\n２３歳\n飲酒Webクリエイター"},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "ブログ書いています"},
            {size : 24, scale : 1.6, color : COLOR_NORMAL, text : "「酒は血液、呑んだら献血」\nhttp://d.hatena.ne.jp"},
            {size : 30, scale : 9, color : COLOR_CATCH, lineColor : COLOR_BG, text : "酒"},
            {size : 24, scale : 2, color : COLOR_CATCH, text : "大好きです(*ﾉﾉ)"},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "今日はまだ\n飲んでいませんので"},
            {size : 24, scale : 1.4, color : COLOR_NORMAL, text : "懇親会で\nActionScriptをつまみに\n飲みましょう!"},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "それでは、本題ヘ"},
            {size : 30, scale : 2.4, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "ベジェ曲線\nBezierCurve"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "２次ベジェ曲線"},
            {demo: demoBezierCurve2D},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "３次ベジェ曲線"},
            {demo: demoBezierCurve3D},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "擬似？\n３次ベジェ曲線"},
            {demo: demoBezierCurve2D3D},
            {size : 24, scale : 1.6, color : COLOR_NORMAL, text : "ベジェ曲線はすごい！"},
            {size : 30, scale : 1.6, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "ベジェ曲線の応用"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "ベジェ曲線を"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "｢動かす｣"},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "制御点１つ動かす"},
            {demo: demoMotionCtrlPoint1},
            {size : 24, scale : 2, color : COLOR_NORMAL, text : "制御点２つ動かす"},
            {demo: demoMotionCtrlPoint2},
            {size : 24, scale : 2, color : COLOR_CATCH, text : "なんか"},
            {size : 24, scale : 2, color : COLOR_CATCH, text : "おもしろい"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "ベジェ曲線を"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "さらに｢動かす｣\n(Tweener)"},
            {demo: demoTweenerGom1},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "もっと"},
            {demo: demoTweenerGom2},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "応用"},
            {demo: demoTweenerArm2},
			{size : 30, scale : 5, color : COLOR_CATCH, lineColor : COLOR_BG, text : "うで？"},
            {demo: demoTweenerArm},
            {size : 30, scale : 2.4, color : COLOR_NORMAL, text : "ぷにぷに"},
            {demo: demoTweenerArm},
            {size : 30, scale : 1, color : COLOR_NORMAL, text : "ActionScriptで\n気になるお肉もスッキリ!!"},
            {demo: demoTweenerArm2},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "ベジェ曲線を"},
            {size : 30, scale : 2, color : COLOR_CATCH, text : "｢塗る｣"},
            {demo: demoCoatLine},
            {size : 30, scale : 3, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "最後に"},
            {size : 30, scale : 3, color : COLOR_BG, lineColor : COLOR_CHAPTER, text : "おまけ"},
            {demo: demoCoatMouthMotion},
            {size : 30, scale : 1.4, color : COLOR_NORMAL, text : "ご清聴\nありがとうございました"}
		];



        /**
         *
         */
		public function WcanAsMiniVol4 () {
            
            so = SharedObject.getLocal("slide");
            index = so.data.index;
            stage.addEventListener("keyDown", keyDownHandler);
            setTimeout(function (): void { show()}, 0);
            arm.visible = false;
            mouth.visible = false;

		}



        /**
         *
         */
		private function keyDownHandler (e: KeyboardEvent): void {
            
            indexBuff = index;

            switch(e.keyCode) {
                
                case Keyboard.RIGHT:
                    next();
                    break;
                
                case Keyboard.LEFT:
                    prev();
                    break;

                case Keyboard.HOME:
                    index = 0;
                    show();
                    break;
                
                case Keyboard.END:
                    index = page.length - 1;
                    show();
                    break;

				case Keyboard.ENTER:
                    if (typingNumber != -1) {
                        index = typingNumber;
                        show();
                    }
                    break;

                case Keyboard.SPACE:
                    lineOnryFlg = !lineOnryFlg;
                    break;
            }

            
            if (48 <= e.keyCode && e.keyCode < 58) {
                if (typingNumber == -1) typingNumber = 0;
                typingNumber = typingNumber * 10 + e.keyCode - 48;
            
            } else {
                typingNumber = -1;
            }
        
        }







        private function prev (): void {
            if(index >= 0) index--;
            show();
		}
        private function next (): void {
            if(index < page.length - 1) index++;
            show(index);
		}







        private function show (index: int = -1): void {

            if(index == -1) {
                index = this.index;
            }

            lineOnryFlg = true;

            index = Math.max(0, index);
            index = Math.min(index, page.length - 1);
            so.data.index = index;
            so.flush();

            clearDemo();
            clearCanvas();

			if(page[index].demo) {
				
                page[index].demo();

                //正式な描画で行う
			    if (page[index].demo == demoBezierCurve2D ||
                    page[index].demo == demoBezierCurve2D3D ||
                    page[index].demo == demoCoatLine ||
                    page[index].demo == demoCoatMouthMotion) {

                    // mouth
                    if (page[index].demo == demoCoatMouthMotion) {
                        mouth.visible = true;
                        lineOnryFlg = false;
                    }

                    addEventListener(Event.ENTER_FRAME, drawBezierCurve2);

                } else {
                    if (page[index].demo == demoTweenerArm ||
                        page[index].demo == demoTweenerArm2) {
                        arm.visible = true;
                        lineOnryFlg = false;
                    }
                    addEventListener(Event.ENTER_FRAME, drawBezierCurve1);
                }

            } else {
                createText(index);
            }

        }







        private function createText (
            index: int
        ): void {

            var w: uint = stage.stageWidth;
            var h: uint = stage.stageHeight;
            var text: String = page[index].text;
            var size: Number = page[index].size;
            var scale: Number = page[index].scale;
            var color: int = page[index].color || 0;
            var lineColor: int =
                page[index].lineColor != null ?
                    page[index].lineColor : color;
			var lines: Array = text.split(/\n/);
            var ll: uint = lines.length;
            var i: uint = 0;
            var count: uint = 0;
            var sprite: Sprite = new Sprite();
            canvas.addChild(sprite);

            addEventListener(Event.ENTER_FRAME, function (e: Event): void {
                
                var sc: Sprite = new Sprite();
                var line: String = lines[i].substr(count, 1);
                var y: Number = (h - ll * size * scale + (i * 20)) / 2;
                var list: ClosedPathList = PotrAs.traceLetter(line, size);
                
                sc.graphics.beginFill(color);
                sc.graphics.lineStyle(1, lineColor);
                list.draw(sc.graphics);
                sc.graphics.endFill();
                sc.scaleX = sc.scaleY = scale;
                sc.x = sprite.width;
                sc.y = y + size * i * scale;
                sprite.addChild(sc);
                center(sprite);
                
                if (lines[i].length - 1 <= count++) {
                    sprite = new Sprite();
                    canvas.addChild(sprite);
                    count = 0;
                    if (ll <= ++i) {
                        removeEventListener(Event.ENTER_FRAME, arguments.callee);
                        trace("end");
                    }
                }

            });
        }


        /**
         * center
         */
        private function center (
            s: DisplayObject,
            vertical: Boolean = false
        ): void {

            var w: int = stage.stageWidth;
            var x: Number = (w - s.width) / 2 - 10;
            s.x = x;

            if (vertical) {
                var h: int = loaderInfo.height;
                var y: Number = (h - s.height) / 2;
                s.y = y;
            }
        }

        private function clearCanvas (): void {
			while(canvas.numChildren) {
				canvas.removeChildAt(0);
			}
            canvas.graphics.clear();
        }
        private function clearDemo (): void {
			while(demo.numChildren) {
				demo.removeChildAt(0);
			}
            //正式な描画で行う aaa
            if (page[indexBuff].demo == demoBezierCurve2D ||
                page[indexBuff].demo == demoBezierCurve2D3D ||
                page[indexBuff].demo == demoCoatLine ||
                page[indexBuff].demo == demoCoatMouthMotion) {
                
                // mouth
                if (page[indexBuff].demo == demoCoatMouthMotion) {
                    mouth.visible = false;
                }

                removeEventListener(Event.ENTER_FRAME, drawBezierCurve2);
            
            } else if (page[indexBuff].demo == demoTweenerArm ||
                       page[indexBuff].demo == demoTweenerArm2) {
                arm.visible = false;
            }
            removeEventListener(Event.ENTER_FRAME, drawBezierCurve1);
        }






        /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
            BEZIER

        >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
        /**
         * initCtrlPoint
         */
        private function initCtrlPoint (
            inType: String,
            inP0: MotionPoint,
            inP1: MotionPoint,
            inR: Number,
            inG: Boolean = false
        ): MotionPoint {

            var offsetX: Number = inP0.x < inP1.x ? inP0.x: inP1.x;
            var offsetY: Number = inP0.y < inP1.y ? inP0.y: inP1.y;
            
            return new MotionPoint(
                inType,
                (Math.abs(inP0.x - inP1.x) / 2) + offsetX,
                (Math.abs(inP0.y - inP1.y) / 2) + offsetY,
                1,
                inR,
                inG
            );
        }
        /**
         * getBezierPosition
         */
        private function getBezierPosition (inP0: MotionPoint, inP1: MotionPoint): StopPoint3D {

            var offsetX: Number = inP0.x < inP1.x ? inP0.x: inP1.x;
            var offsetY: Number = inP0.y < inP1.y ? inP0.y: inP1.y;
            
            return new StopPoint3D(
                Math.abs(inP0.x - inP1.x) / 2 + offsetX,
                Math.abs(inP0.y - inP1.y) / 2 + offsetY
            );
        }



        /**
         * 擬似ベジェ曲線
         */
        private function drawBezierCurve2 (e: Event): void {

            var i: uint;
            var j: uint;

            var p0: MotionPoint = bezierPoints[0];
            var p1: MotionPoint;
            var cp0: MotionPoint;
            var cp1: MotionPoint;

            // 三次ベジェ曲線描画
            for (i = 0; i < maxPointNumber - 1; i++) {
                if (i != 0 && i != maxPointNumber - 1) {
                    var dp: StopPoint3D = getBezierPosition(ctrlPoints[i - 1], ctrlPoints[i]);
                    bezierPoints[i].px = dp.x;
                    bezierPoints[i].py = dp.y;
                }
            }

            canvas.graphics.clear();
            if (lineWeight) {
                canvas.graphics.lineStyle(0, COLOR_NORMAL, 0);
                canvas.graphics.beginFill(COLOR_NORMAL, 1);
            } else {
                canvas.graphics.lineStyle(4, COLOR_NORMAL, 1);
            }
            canvas.graphics.moveTo(p0.x, p0.y/* - lineWeight*/);

            for (i = 0; i < maxPointNumber - 1; i++) {
                p1 = bezierPoints[i + 1];
                cp0 = ctrlPoints[i];
                canvas.graphics.curveTo(cp0.x, cp0.y, p1.x, p1.y);
                p0.visible = p1.visible = cp0.visible = lineOnryFlg;
            }
            if (lineWeight) {
                canvas.graphics.lineTo(p1.x, p1.y/* + lineWeight*/);
                for (i = maxPointNumber - 1; i > 0; i--) {
                    p1 = bezierPoints[i - 1];
                    cp0 = ctrlPoints[i - 1];
                    if (i == 2) canvas.graphics.curveTo(cp0.x, cp0.y + lineWeight, p1.x, p1.y + lineWeight);
                    else canvas.graphics.curveTo(cp0.x, cp0.y + lineWeight, p1.x, p1.y/* + lineWeight*/);
                }
            }
            canvas.graphics.endFill();
            
            if (!lineOnryFlg) return;
            
            canvas.graphics.lineStyle(4, COLOR_CHAPTER, 1);
            canvas.graphics.moveTo(p0.x, p0.y);
            for (i = 0; i < maxCtrlPointNumber; i++) {
                canvas.graphics.lineTo(ctrlPoints[i].x, ctrlPoints[i].y);
            }
            canvas.graphics.lineTo(bezierPoints[maxPointNumber - 1].x, bezierPoints[maxPointNumber - 1].y);
            canvas.graphics.endFill();

        }
        /**
         * 正式な描画
         */
        private function drawBezierCurve1 (e: Event): void {

            var i: uint;
            var k: uint;

            canvas.graphics.clear();

            // 三次ベジェ曲線描画
            for (i = 0; i < maxPointNumber - 1; i++) {// 最大数マイナス1の値
                
                var p0:  MotionPoint = bezierPoints[i];
                var p1:  MotionPoint = bezierPoints[i + 1];
                var cp0: MotionPoint = ctrlPoints[i];
                var cp1: MotionPoint = ctrlPoints[maxCtrlPointNumber - 1];

                p0.visible = p1.visible = cp0.visible = cp1.visible = lineOnryFlg;

                canvas.graphics.lineStyle(4, COLOR_NORMAL, 1);
                canvas.graphics.moveTo(p0.x, p0.y);

                for (k = 0; k < maxTPointNumber; k++) {
                    var tp1: StopPoint3D = bezierTest(
                        Number((1 / maxTPointNumber) * k), p0, p1, cp0, cp1);
                    var tp2: StopPoint3D = bezierTest(
                        Number((1 / maxTPointNumber) * (k + 1)), p0, p1, cp0, cp1);
                    canvas.graphics.lineTo(tp1.x, tp1.y)
                    canvas.graphics.lineTo(tp2.x, tp2.y)
                }
                canvas.graphics.endFill();
            }

            if (!lineOnryFlg) return;

            canvas.graphics.lineStyle(2, COLOR_CHAPTER, 1);
            canvas.graphics.moveTo(p0.x, p0.y);
            for (i = 0; i < maxCtrlPointNumber; i++) {
                canvas.graphics.lineTo(ctrlPoints[i].x, ctrlPoints[i].y);
            }
            canvas.graphics.lineTo(bezierPoints[maxPointNumber - 1].x, bezierPoints[maxPointNumber - 1].y);
            canvas.graphics.endFill();

        }

        private function bezierTest (
            t: Number,
            inP0: MotionPoint,
            inP1: MotionPoint,
            inCp0: MotionPoint,
            inCp1: MotionPoint
        ): StopPoint3D {
            
            var tp: Number = 1.0 - t;
            return new StopPoint3D(
                        Math.pow(1 - t, 3)  * inP0.x + 3 * t * Math.pow(1 - t, 2) * inCp0.x
                        + 3 * t * t * (1 - t) * inCp1.x + t * t * t * inP1.x,
                        Math.pow(1 - t, 3)  * inP0.y + 3 * t * Math.pow(1 - t, 2) * inCp0.y
                        + 3 * t * t * (1 - t) * inCp1.y + t * t * t * inP1.y);
        
        }






        /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
            DEMO: 説明

        >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
        /**
         * demoWhatsBezierCurve
         */
        private function demoWhatsBezierCurve (): void {
            trace("DEMO: demoWhatsBezierCurve");

        }
        /**
         * demoBezierCurve2D
         */
        private function demoBezierCurve2D (): void {
            trace("DEMO: demoBezierCurve2D");
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;

            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                initCtrlPoint(
                    MotionPoint.TYPE_CTRL_POINT, bezierPoints[0], bezierPoints[1], CTRL_POINT_RADIUS));

            ctrlPoints[0].py = h / 4;
            demoCommonsFunction();
        }
        /**
         * demoBezierCurve3D
         */
        private function demoBezierCurve3D (): void {
            trace("DEMO: demoBezierCurve3D");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h / 4,
                    1,
                    CTRL_POINT_RADIUS),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h / 4,
                    1,
                    CTRL_POINT_RADIUS)
            );
            demoCommonsFunction();
        }
        /**
         * demoBezierCurve2D3D
         */
        private function demoBezierCurve2D3D (): void {
            trace("DEMO: demoBezierCurve2D3D");
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 2, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                initCtrlPoint(MotionPoint.TYPE_CTRL_POINT, bezierPoints[0], bezierPoints[1], CTRL_POINT_RADIUS),
                initCtrlPoint(MotionPoint.TYPE_CTRL_POINT, bezierPoints[1], bezierPoints[2], CTRL_POINT_RADIUS)
            );
            ctrlPoints[0].py = ctrlPoints[1].py = h / 4;
            demoCommonsFunction();
        }
        /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
            DEMO: Anime

        >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
        /**
         * demoMotionCtrlPoint1
         */
        private function demoMotionCtrlPoint1 (): void {
            trace("DEMO: demoMotionCtrlPoint1");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h / 8,
                    1,
                    CTRL_POINT_RADIUS),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h / 4,
                    1,
                    CTRL_POINT_RADIUS)
            );
            ctrlPoints[0].roopAnime(w / 2 - w / 8, h / 8, w / 2 - w / 8, h - h / 8, 1, "linear");
            demoCommonsFunction();
        }
        /**
         * demoMotionCtrlPoint2
         */
        private function demoMotionCtrlPoint2 (): void {
            trace("DEMO: demoMotionCtrlPoint2");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h - h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false)
            );
            ctrlPoints[0].roopAnime(w / 2 - w / 8, h / 8, w / 2 - w / 8, h - h / 8, 1, "linear");
            ctrlPoints[1].roopAnime(w / 2 + w / 8, h - h / 8, w / 2 + w / 8, h / 8, 1, "linear");
            demoCommonsFunction();
        }






        /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
            DEMO: Tweener

        >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
        /**
         * demoTweenerGom1
         */
        private function demoTweenerGom1 (): void {
            trace("DEMO: demoTweenerGom1");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h - h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false)
            );
            ctrlPoints[0].roopAnime(w / 2 - w / 8, h / 8, w / 2 - w / 8, h - h / 8, 1, "easeInOutBounce");
            ctrlPoints[1].roopAnime(w / 2 + w / 8, h - h / 8, w / 2 + w / 8, h / 8, 1, "easeInOutBounce");
            demoCommonsFunction();
        }
        /**
         * demoTweenerGom2
         */
        private function demoTweenerGom2 (): void {
            trace("DEMO: demoTweenerGom2");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 4, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w - w / 4, h / 2, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h - h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false)
            );
            bezierPoints[0].roopAnime(w / 8, h / 8, w / 2 - w / 8, h - h / 8, 1, "easeInBack");
            bezierPoints[1].roopAnime(20, h / 2, w - 20, h / 2, 4, "easeInExpo");
            ctrlPoints[0].roopAnime(w / 2 - w / 8, h / 8, w / 2 - w / 8, h - h / 8, .3, "easeInOutBack");
            ctrlPoints[1].roopAnime(w / 2 + w / 8, h - h / 8, w - w / 8, h / 8, 1.6, "easeInOutElastic");
            demoCommonsFunction();
        }
        /**
         * demoTweenerArm
         */
        private function demoTweenerArm (): void {
            trace("DEMO: demoTweenerArm");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 138, 250, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 266, 260, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h - h / 10,
                    1,
                    CTRL_POINT_RADIUS, false, false),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h - h / 10,
                    1,
                    CTRL_POINT_RADIUS, false, false)
            );
            ctrlPoints[0].roopAnime(w / 2 - w / 8, h - h / 10, w / 2, h - h / 20, .4, "easeInOutBack");
            ctrlPoints[1].roopAnime(w / 2 + w / 8, h - h / 10, w / 2 + w / 20, h, .4, "easeInOutBounce");
            demoCommonsFunction();
        }
        /**
         * demoTweenerArm2
         */
        private function demoTweenerArm2 (): void {
            trace("DEMO: demoTweenerArm2");
            maxTPointNumber = 50;
            lineWeight = 0;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 138, 250, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 266, 260, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 - w / 8,
                    h - h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false),

                new MotionPoint(
                    MotionPoint.TYPE_CTRL_POINT,
                    w / 2 + w / 8,
                    h - h / 8,
                    1,
                    CTRL_POINT_RADIUS, false, false)
            );
            demoCommonsFunction();
        }






        /* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            
            DEMO: 塗る

        >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */
        /**
         * demoCoatLine
         */
        private function demoCoatLine (): void {
            trace("DEMO: demoCoatLine");
            lineWeight = 40;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 0, 0, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w, h / 2, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w, h, 1, BEZIER_POINT_RADIUS)
            );

            ctrlPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_CTRL_POINT, w / 2 - w / 8, h / 4, 1, BEZIER_POINT_RADIUS, true),
                new MotionPoint(MotionPoint.TYPE_CTRL_POINT, w / 2 + w / 8, h - h / 4, 1, BEZIER_POINT_RADIUS, true)
            );
            bezierPoints[0].roopAnime(0, 0, 0, h, 1, "easeInBack");
            bezierPoints[2].roopAnime(w, h, w, 0, 1, "easeInBack");
            demoCommonsFunction();
        }
        /**
         * demoCoatMouthMotion
         */
        private function demoCoatMouthMotion (): void {
            trace("DEMO: demoCoatMouthMotion");
            lineWeight = 29;
            var w: Number = stage.stageWidth;
            var h: Number = stage.stageHeight;
            
            bezierPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 109, 204, 1, BEZIER_POINT_RADIUS, true),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, w / 2, 204, 1, BEZIER_POINT_RADIUS),
                new MotionPoint(MotionPoint.TYPE_BEZIER_POINT, 247, 204, 1, BEZIER_POINT_RADIUS, true)
            );

            ctrlPoints = new Array(
                new MotionPoint(MotionPoint.TYPE_CTRL_POINT, w / 2 - w / 4,  h - h / 6, 1, BEZIER_POINT_RADIUS, true),
                new MotionPoint(MotionPoint.TYPE_CTRL_POINT, w / 2 + w / 4, h - h / 6, 1, BEZIER_POINT_RADIUS, true)
            );
            ctrlPoints[0].roopAnime(w / 2 - w / 4, h - h / 6, w / 2 - w / 8, h - h / 3, .2, "easeInOutBounce")
            ctrlPoints[1].roopAnime(w / 2 + w / 4, h - h / 6, w / 2 + w / 8, h - h / 3, .2, "easeInOutBounce")

            demoCommonsFunction();
        }



        /**
         *
         */
        private function demoCommonsFunction (): void {
            var i: uint;
            maxPointNumber = bezierPoints.length;
            maxCtrlPointNumber = ctrlPoints.length;
            
            for (i = 0; i < maxPointNumber; i++)
                demo.addChild(bezierPoints[i]);
            for (i = 0; i < maxCtrlPointNumber; i++)
                demo.addChild(ctrlPoints[i]);
        }



    }
}

